//here should be the new versions of functions we receive

#include "hookedfunctions.h" //function definitions for this file
#include "clientcommands.h"

#include "plugin.h"
#include "utilfunctions.h"

float WeldAmount;
bool extralevels;

int Spawn(edict_t *pEntity) {
	if (FStrEq(STRING(pEntity->v.classname), "worldspawn"))
	{
		extralevels = (CVAR_GET_POINTER("extralevels_version") != NULL);
		DynamicSizedData.Initialize();
		RETURN_META_VALUE(MRES_HANDLED, 0);
	}

	RETURN_META_VALUE(MRES_IGNORED, 0);
}
BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  ) {
	int iPlayerNum = ENTINDEX(pEntity);
	DynamicSizedData.fLastSelfWeldTime[iPlayerNum] = 0.0f;

	RETURN_META_VALUE(MRES_HANDLED, true);
}
void ClientDisconnect( edict_t *pEntity ) {
	int iPlayerNum = ENTINDEX(pEntity);
	DynamicSizedData.fLastSelfWeldTime[iPlayerNum] = 0.0f;

	RETURN_META(MRES_HANDLED);
}

void PlayerPreThink( edict_t *pEntity ) 
{
	int ArmorValueAddon = 0;
	float FinalArmorValue = 0.0f;
	float WeldAmount = 0;
	int iPlayerNum = 0;

	if(pEntity == NULL) RETURN_META(MRES_IGNORED);
	if(pEntity->v.iuser3 != 1) RETURN_META(MRES_IGNORED);//not rine!

	if(pEntity->v.button & IN_ATTACK) 
	{ //bang bang!

		if(!(FStrEq(STRING(pEntity->v.viewmodel), "models/v_welder_hv.mdl") | FStrEq(STRING(pEntity->v.viewmodel), "models/v_welder.mdl")))
			RETURN_META(MRES_IGNORED);//He is not using a welder...

		iPlayerNum = ENTINDEX(pEntity);
		if( ABSOLUTE_VALUE_EASY( gpGlobals->time - DynamicSizedData.fLastSelfWeldTime[iPlayerNum] ) > 0.8f ) 
		{
			DynamicSizedData.fLastSelfWeldTime[iPlayerNum] = gpGlobals->time;
			//time for a self weld if the person is looking straight down
			if(pEntity->v.v_angle.x > 80.0f) 
			{
				CBaseEntity *lookingat = FindEntityForward( (CBaseEntity *)GET_PRIVATE( pEntity ) );
				if(canWeld(lookingat))
				{					
					//-- If we got this far, I think its time to weld the guy!
					
					/* Since Each Armor value increases the same amount
					I figured instead of doing a if for each one of these on Heavy
					or not, Why not just get a value of how many upgrades and multiply
					for final answer @ the end */

					if(pEntity->v.iuser4 & ARMOR_1)
					{
						ArmorValueAddon++;
						if(pEntity->v.iuser4 & ARMOR_2)
						{
							ArmorValueAddon++;
							if(pEntity->v.iuser4 & ARMOR_3)
								ArmorValueAddon++;
						}
					}
					if(pEntity->v.iuser4 & 32768)
						FinalArmorValue = 30 * ArmorValueAddon + 200; //HA increments of 30, base armor 200
					else
						FinalArmorValue = 20 * ArmorValueAddon + 30; //LA increments of 20, base armor 30

					if( pEntity->v.armorvalue >= FinalArmorValue ) RETURN_META(MRES_IGNORED);
					if( DynamicSizedData.fMaxArmor[iPlayerNum] > FinalArmorValue ) FinalArmorValue = DynamicSizedData.fMaxArmor[iPlayerNum];
					WeldAmount = CVAR_GET_FLOAT("selfweld_amount");
					FinalArmorValue *= CVAR_GET_FLOAT("selfweld_percent");
					if((pEntity->v.armorvalue + WeldAmount) <= FinalArmorValue) 
					{
						pEntity->v.armorvalue += WeldAmount;
					} 
					else if((FinalArmorValue - pEntity->v.armorvalue) > 0) 
					{
						pEntity->v.armorvalue += (FinalArmorValue - pEntity->v.armorvalue);
					}
					RETURN_META(MRES_HANDLED);
				}
			}//angle!
			RETURN_META(MRES_IGNORED);
		}
		RETURN_META(MRES_IGNORED);
	}
	RETURN_META(MRES_IGNORED);
}

void StartFrame ( void ) {
	if(extralevels)
	{
		CBaseEntity *pPlayer;
		for (int counter = 1; counter <= gpGlobals->maxClients + 1; ++counter)
		{
			pPlayer = UTIL_PlayerByIndex(counter);
			if (pPlayer == NULL) continue;
			if (pPlayer->pev->armorvalue > DynamicSizedData.fMaxArmor[counter]) DynamicSizedData.fMaxArmor[counter] = pPlayer->pev->armorvalue;
		}
	}
	RETURN_META(MRES_IGNORED);
}

bool canWeld(CBaseEntity *pEntity)
{
	if (pEntity == NULL)
		return true;
	if (FStrEq(STRING(pEntity->pev->classname),"defensechamber"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"offensechamber"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"movementchamber"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"sensorychamber"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_hive"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"player"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_command"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"alienresourcetower"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"resourcetower"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"turret"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"siegeturret"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"phasegate"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_turretfactory"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_advturretfactory"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_armory"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_advarmory"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_armslab"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_protolab"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_observatory"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"team_infportal"))
		return false;
	if (FStrEq(STRING(pEntity->pev->classname),"item_mine"))
		return false;
	return true;
}
