//This should contain plugin information and definitions for 
//helper functions

#ifndef _PLUGIN_H_
#define _PLUGIN_H_

//=================================================================
//Plugin Information
//=================================================================
#define MY_DATE			"Feb 19, 2005" //dd/mm/yy
#define MY_NAME			"SelfWeld"
#define MY_AUTHOR		"[WHO]Them, Scottl & P34CH_34732"
#define MY_URL			"www.clanwho.com"
#define MY_LOGTAG		"SELFWELD"
#define MY_VERSION		"1.31"
#define MY_LOADABLE		PT_ANYTIME
#define MY_UNLOADABLE	PT_ANYTIME


#define MY_VERS_DWORD	1,3,1,0
#define MY_COMMENTS		"If you like it, lemme know, them@clanwho.com"
#define MY_DESC			"People can weld themselves by looking straight down"
#define MY_FILENAME		MY_LOGTAG ".DLL"
#define MY_INTERNAL		MY_LOGTAG
#define MY_COPYRIGHT	"I want my name in big letters and bright lights; licensed under the GPL"


#define ABSOLUTE_VALUE_EASY(x) (((x) < 0) ? (-(x)) : (x))

//=================================================================
//the grand old initialization function
//=================================================================
void plugin_init(void);

//=================================================================
//the grand old quit function
//=================================================================
void plugin_quit(void);



struct DynDataAutoCleanUp { //used for variables that will have a dynamic size, so we can be 100% sure that they will clean themselves up when the dll unloads
	bool isInitialized; //used for easy initialization constancy (so i can cut/paste code for lots of plugins with minimal changes)

	float *fLastSelfWeldTime;
	float *fMaxArmor;
	int *iHeavyArmor;

	//set default values
	DynDataAutoCleanUp( void ) {
		isInitialized = false;
		fLastSelfWeldTime = NULL;
		fMaxArmor = NULL;
		iHeavyArmor = NULL;
	}

	//the entire reason this class exists
	~DynDataAutoCleanUp( void ) {
		if(isInitialized) {
			delete []fLastSelfWeldTime;
			delete []fMaxArmor;
			delete []iHeavyArmor;
			isInitialized = false; //just in case
		}
	}

	void Initialize( void ) {
		if( (gpGlobals->maxClients == 0) || isInitialized) return;

		fLastSelfWeldTime = new float [gpGlobals->maxClients + 1]; //add one cuz it's just easier to use 1 through maxplayers than 0 through maxplayers-1 (less on the fly arithmetic)
		fMaxArmor = new float [gpGlobals->maxClients + 1];
		iHeavyArmor = new int [gpGlobals->maxClients + 1];
		
		for(int playercounter = 0; playercounter <= gpGlobals->maxClients; ++playercounter) {
			fLastSelfWeldTime[playercounter] = 0.0f;
			fMaxArmor[playercounter] = 0.0f;
			iHeavyArmor[playercounter] = 0;
		}

		isInitialized = true;
	}
};
extern DynDataAutoCleanUp DynamicSizedData;




//=================================================================
//helper functions
//=================================================================
float strtofloat( const char *szStringToConvert );
int strtoint( const char *szStringToConvert );

//simplify the process of registering a user message without stepping on anyone else's code unless we have to
inline void SAFE_USER_MSG(int &gmsgvar, const char *szMsgName, const int &iSize) {
	if(gmsgvar == 0) 
	{
		//attempt to get the msg from the game that's running
		gmsgvar = GET_USER_MSG_ID( &Plugin_info, szMsgName, NULL);
		
		//and if that fails, register it ourselves
		if(gmsgvar == 0) gmsgvar = REG_USER_MSG(szMsgName, iSize);
	}
}





#endif // _PLUGIN_H_



